//    WeIRCd administration tool
//    Copyright (C) 2009-2010 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "admintool.h"

GdkPixbuf* pixbuf_general;
GdkPixbuf* pixbuf_listen;
GdkPixbuf* pixbuf_floodprotect;
GdkPixbuf* pixbuf_adminaccounts;
GdkPixbuf* applogo;
int loadwinlogo() {
	gdk_threads_enter();
	GError *error = NULL;
	gui_splash_createpicdir();
	char picpath[500];
	snprintf(picpath,499,"%sappicon.ico",picdir);
	applogo = gdk_pixbuf_new_from_file(picpath,&error);
	if (error != NULL) {
		gdk_threads_leave();
		return -1;
	}
	gdk_threads_leave();
	return 0;
}
int loadicons() {
	gdk_threads_enter();
	GError *error = NULL;
	gui_splash_createpicdir();
	char picpath[500];
	snprintf(picpath,499,"%sicon_settings_general.png",picdir);
	pixbuf_general = gdk_pixbuf_new_from_file(picpath,&error);
	if (error != NULL) {
		gdk_threads_leave();
		return -1;
	}
	snprintf(picpath,499,"%sicon_settings_listen.png",picdir);
	pixbuf_listen = gdk_pixbuf_new_from_file(picpath,&error);
	if (error != NULL) {
		gdk_threads_leave();
		return -1;
	}
	snprintf(picpath,499,"%sicon_settings_floodprotect.png",picdir);
	pixbuf_floodprotect = gdk_pixbuf_new_from_file(picpath,&error);
	if (error != NULL) {
		gdk_threads_leave();
		return -1;
	}
	snprintf(picpath,499,"%sicon_settings_adminaccounts.png",picdir);
	pixbuf_adminaccounts= gdk_pixbuf_new_from_file(picpath,&error);
	if (error != NULL) {
		gdk_threads_leave();
		return -1;
	}
	gdk_threads_leave();
	return 0;
}
int categorylist_getfocus(struct settingstab* s) {
	GtkTreePath *pth;
	GtkTreeViewColumn *cl;
	gtk_tree_view_get_cursor(GTK_TREE_VIEW(s->categoriesview),&pth,&cl);
	if (pth == NULL) {
                return -1;
        }else{
		unsigned char* p = gtk_tree_path_to_string(pth);
		if (p == NULL) {gtk_tree_path_free(pth);return -1;}
		unsigned char* cpy = alloca(strlen(p)+1);
		if (cpy == NULL) {free(p);gtk_tree_path_free(pth);return -1;}
		strcpy(cpy,p);free(p);gtk_tree_path_free(pth);
		if (charpos(cpy,':') > 0) {cpy[charpos(cpy,':')] = 0;}
		int val = atoi(cpy);
		return val;
	}
}
void constructsettings_subtab_showbyname(struct settingstab* s, const char* name);
void click(struct settingstab* s) {
	int i = categorylist_getfocus(s);
	if (i == 0) {
		constructsettings_subtab_showbyname(s,"general");
	}
	if (i == 1) {
		constructsettings_subtab_showbyname(s,"adminaccounts");
	}
	if (i == 2) {
		constructsettings_subtab_showbyname(s,"listen");
	}
	if (i == 3) {
		constructsettings_subtab_showbyname(s,"floodprotection");
	}
}
void settingsrowactivated(GtkTreeView       *tree_view,
                          GtkTreePath       *path,
                          GtkTreeViewColumn *column,
                          gpointer           user_data) {
	click((struct settingstab*)user_data);
}
void  settingsrowchanged(GtkTreeView *tree_view, gpointer user_data) {
	click((struct settingstab*)user_data);
}
void somethingchanged(struct settingstab* s) {
	gtk_widget_set_sensitive(s->applybutton, TRUE);
	gtk_widget_set_sensitive(s->discardbutton, TRUE);
}
void widgetvaluechanged(GtkWidget *w, gpointer user_data) {
	struct settingstab* s = user_data;
	if (s->dontwatchchanges == 1) {return;}
	somethingchanged(s);
}
void* constructsettings_addsettingssubtab(struct settingstab* s, const char* name) { /* add a sub tab which is a single settings page/category */
	GtkWidget* vbox = gtk_vbox_new(FALSE,0);gtk_widget_show(vbox); /* OUTER VBOX */
	g_object_ref(vbox); //we want to keep it even if it gets attached and deattached until we explicitely delete the sub tab
	struct settingssubtab t;
	memset(&t,0,sizeof(t));
	t.parentbox = vbox; /* children will be attached to this */
	t.parenttab = s;
	t.name = malloc(strlen(name)+1);strcpy(t.name,name);
	printf("Creating settings category tab '%s'\n",name);
	return linkedlist_Append(&s->settingssubtabslist,&t,sizeof(t));
}
void constructsettings_subtab_addheading(void* subtabptr, const char* markup) {
	/* creating a label and packaging it */
	struct settingssubtab* t = linkedlist_GetData(subtabptr);
	GtkWidget* hbox = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(t->parentbox), hbox, FALSE, FALSE, 4);
	GtkWidget* lbl = gtk_label_new("");
	gtk_label_set_markup(GTK_LABEL(lbl), markup);
	gtk_misc_set_alignment(GTK_MISC(lbl), 0,0);
	gtk_widget_show(lbl);
	gtk_box_pack_start(GTK_BOX(hbox), lbl, FALSE, FALSE, 4);
	gtk_widget_show(hbox);
}
void constructsettings_subtab_addsetting(void* subtabptr, const char* name, const char* title, int type) {
	/* creating a hbox with text & data widget and packaging it */
	printf("adding setting \"%s\"\n",name);
	
	struct settingssubtab* t = linkedlist_GetData(subtabptr);
	struct settingsvalue v;
	memset(&v,0,sizeof(v));
	v.type = type;
	v.name = malloc(strlen(name)+1);strcpy(v.name,name);
	
	GtkWidget* hbox = gtk_hbox_new(FALSE,0); /* our hbox */
	gtk_box_pack_start(GTK_BOX(t->parentbox), hbox, FALSE, FALSE, 0); /* pack our hbox */
	GtkWidget* lbl = gtk_label_new(title); /* get a label and... */
	gtk_widget_show(lbl);
	gtk_box_pack_start(GTK_BOX(hbox), lbl, FALSE, FALSE, 4); /* ... package it into the hbox */
	if (type == VARTYPE_ENTRY) { /* data type is a text entry field, so use a text entry */
		v.settingswidget = gtk_entry_new();
		g_signal_connect (v.settingswidget, "changed", 
			G_CALLBACK (widgetvaluechanged), t->parenttab);
	}
	if (type == VARTYPE_INTCOUNT) { /* data type is a text entry field, so use a text entry */
		v.settingswidget = gtk_spin_button_new_with_range(1,50,1);
		g_signal_connect (v.settingswidget, "changed", 
			G_CALLBACK (widgetvaluechanged), t->parenttab);
	}
	if (v.settingswidget != NULL) { /* if data type is valid we have now a widget ... */
		gtk_widget_show(v.settingswidget); /* ... which we will put into our hbox secondly */
		gtk_box_pack_end(GTK_BOX(hbox), v.settingswidget, FALSE, FALSE, 4);
	}
	/* ok, our hbox is done */
	gtk_widget_show(hbox);
	linkedlist_Append(&t->valueslist,&v,sizeof(v));
}
void constructsettings_subtab_addsetting_combo(void* subtabptr, const char* name, const char* title, const char** values) {
	/* creating a hbox with text & data widget and packaging it */
	printf("adding combo setting \"%s\"\n",name);
	
	struct settingssubtab* t = linkedlist_GetData(subtabptr);
	struct settingsvalue v;
	memset(&v,0,sizeof(v));
	v.type = VARTYPE_COMBOBOX;
	v.name = malloc(strlen(name)+1);strcpy(v.name,name);
	
	GtkWidget* hbox = gtk_hbox_new(FALSE,0); /* our hbox */
	gtk_box_pack_start(GTK_BOX(t->parentbox), hbox, FALSE, FALSE, 0); /* pack our hbox */
	GtkWidget* lbl = gtk_label_new(title); /* get a label and... */
	gtk_widget_show(lbl);
	gtk_box_pack_start(GTK_BOX(hbox), lbl, FALSE, FALSE, 4); /* ... package it into the hbox */
	/* now obtain our combo box... */
	v.settingswidget = gtk_combo_box_new_text();
	/* ...and fill in our values */
	int r = 0;
	while (values[r] != 0) { /* nullterminated list */
		gtk_combo_box_append_text(GTK_COMBO_BOX(v.settingswidget),values[r]);
		r++;
	}
	/* pack the combo box into our hbox */
	gtk_box_pack_end(GTK_BOX(hbox), v.settingswidget, FALSE, FALSE, 4);
	gtk_widget_show(v.settingswidget); //make it visible
	g_signal_connect (v.settingswidget, "changed", 
			G_CALLBACK (widgetvaluechanged), t->parenttab);
	/* ok, our hbox is done */
	gtk_widget_show(hbox);
	linkedlist_Append(&t->valueslist,&v,sizeof(v));
}
void constructsettings_subtab_show(void* subtabptr) {
	printf("attempting to show sub tab\n");
	/* show the specific sub tab with all its contents */
	struct settingssubtab* t = linkedlist_GetData(subtabptr);
	struct settingstab* s = t->parenttab;
	if (s->shownsubtab != NULL) {
		GtkWidget* viewport = gtk_bin_get_child(GTK_BIN(s->contentscroller));
		
		gtk_container_remove(GTK_CONTAINER(viewport), s->shownsubtab);
		gtk_container_remove(GTK_CONTAINER(s->contentscroller), viewport);
	}
	s->shownsubtab = t->parentbox;
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(s->contentscroller), t->parentbox);
}
void constructsettings_subtab_showbyname(struct settingstab* s, const char* name) {
	printf("Showing tab %s now.\n",name);
	void* item = s->settingssubtabslist;
	while (item  != NULL) {
		struct settingssubtab* t = linkedlist_GetData(item);
		if (t->name != NULL) {
			if (strcasecmp(t->name,name) == 0) {
				constructsettings_subtab_show(item);
				return;
			}
		}
		item = linkedlist_NextItem(item);
	}
}
void gevent_applybutton_clicked(GtkButton *button, gpointer user_data) {
	struct settingstab* s = user_data;
	gtk_widget_set_sensitive(s->applybutton,FALSE);
	gtk_widget_set_sensitive(s->discardbutton, FALSE);
	//transfer settings back into our config value store
	transfer_guitoconfig(s);
	//then transfer back (lol :D) to pass it to any other opened local install tabs
	transfer_configtogui(NULL);
	if (gui_UpdateTabConfig(s->parentnotebook->parenttab) != 0) {
		GtkWidget* dlg = gtk_message_dialog_new(NULL,0,
		GTK_MESSAGE_ERROR,
		GTK_BUTTONS_OK,
		"Failed to update configuration",NULL);
		gtk_window_set_title(GTK_WINDOW(dlg),"Fatal error");
		gtk_window_set_position(GTK_WINDOW(dlg), GTK_WIN_POS_CENTER);
		gtk_widget_show(dlg);
	}
	mainwindowaction_RehashServer();
}
void gevent_discardbutton_clicked(GtkButton *button, gpointer user_data) {
	struct settingstab* s = user_data;
	gtk_widget_set_sensitive(s->applybutton,FALSE);
	gtk_widget_set_sensitive(s->discardbutton, FALSE);
	transfer_configtogui(s);//retransfer config data, this will overwrite changed data
}
void constructsettings(struct controlnotebook* parentnotebook, GtkWidget* frame, struct settingstab* s) {
	printf("badammm\n");
	s->parentnotebook = parentnotebook;
	s->parentframe = frame;
	GtkWidget* v = gtk_vbox_new(TRUE,0);gtk_widget_show(v);
	gtk_box_pack_start(GTK_BOX(frame),v,TRUE,TRUE,0);
	
	GtkWidget* h = gtk_hbox_new(FALSE,0);gtk_widget_show(h);
	gtk_box_pack_start(GTK_BOX(v),h,TRUE,TRUE,2);
	
	s->categoriesstore = gtk_list_store_new(2, GDK_TYPE_PIXBUF, G_TYPE_STRING);
	
	GtkTreeIter iter;
	
	gtk_list_store_append(s->categoriesstore, &iter);
	gtk_list_store_set(s->categoriesstore, &iter, 0, pixbuf_general, 1, "General Settings", -1);
	
	gtk_list_store_append(s->categoriesstore, &iter);
	gtk_list_store_set(s->categoriesstore, &iter, 0, pixbuf_adminaccounts, 1, "Admin Accounts", -1);
	
	gtk_list_store_append(s->categoriesstore, &iter);
	gtk_list_store_set(s->categoriesstore, &iter, 0, pixbuf_listen, 1, "Listen Ports", -1);
	
	gtk_list_store_append(s->categoriesstore, &iter);
	gtk_list_store_set(s->categoriesstore, &iter, 0, pixbuf_floodprotect, 1, "Flood Protection", -1);
	
	s->categoriesview = gtk_tree_view_new_with_model(GTK_TREE_MODEL(s->categoriesstore));
	gtk_widget_show(s->categoriesview);
	GtkWidget* scroller = gtk_scrolled_window_new(NULL, NULL);gtk_widget_show(scroller);
	gtk_widget_set_size_request(scroller,160,-1);
	
	GtkWidget* categories_applydiscard_vbox = gtk_vbox_new(FALSE,0);gtk_widget_show(categories_applydiscard_vbox);
	
	gtk_box_pack_start(GTK_BOX(h), categories_applydiscard_vbox, FALSE, FALSE, 2);
	gtk_box_pack_start(GTK_BOX(categories_applydiscard_vbox), scroller, TRUE, TRUE, 2);
	gtk_container_add(GTK_CONTAINER(scroller), s->categoriesview);
	gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scroller), GTK_SHADOW_IN);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroller), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	
	/* hbox for apply/discard */
	GtkWidget* applydiscard_hbox = gtk_hbox_new(FALSE,0);gtk_widget_show(applydiscard_hbox);
	gtk_box_pack_start(GTK_BOX(categories_applydiscard_vbox), applydiscard_hbox, FALSE, FALSE, 2);
	/* apply/discard buttons */
	s->applybutton = gtk_button_new_with_label("Apply");
	gtk_widget_show(s->applybutton);
	s->discardbutton = gtk_button_new_with_label("Discard");
	gtk_widget_show(s->discardbutton);
	gtk_widget_set_sensitive(s->applybutton,FALSE);
	gtk_widget_set_sensitive(s->discardbutton,FALSE);
	g_signal_connect(G_OBJECT(s->applybutton), "clicked", G_CALLBACK(gevent_applybutton_clicked),
				 s);
	g_signal_connect(G_OBJECT(s->discardbutton), "clicked", G_CALLBACK(gevent_discardbutton_clicked),
				 s);
	gtk_box_pack_start(GTK_BOX(applydiscard_hbox),s->applybutton, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(applydiscard_hbox),s->discardbutton, TRUE, TRUE, 0);
	
	GtkCellRenderer* renderer = gtk_cell_renderer_pixbuf_new  ();
	GtkTreeViewColumn *column = gtk_tree_view_column_new_with_attributes (NULL,
						renderer,
						"pixbuf",0,
						NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW(s->categoriesview), column);
	
	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes (NULL,
						renderer,
						"text", 1,
						NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW(s->categoriesview), column);
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(s->categoriesview), FALSE);
	
	g_signal_connect (s->categoriesview, "row-activated", 
			G_CALLBACK (settingsrowactivated), s);
	g_signal_connect (s->categoriesview, "cursor-changed", 
			G_CALLBACK (settingsrowchanged), s);
	
	s->contentscroller = gtk_scrolled_window_new(NULL, NULL);gtk_widget_show(s->contentscroller);
	GtkWidget* spacingh = gtk_vbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(h), spacingh, TRUE, TRUE, 2);gtk_widget_show(spacingh);
	gtk_box_pack_start(GTK_BOX(spacingh), s->contentscroller, TRUE, TRUE, 2);
	gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(s->contentscroller), GTK_SHADOW_NONE);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(s->contentscroller), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	
	/* now create settings tabs */
	void* t = constructsettings_addsettingssubtab(s,"general");
	
	constructsettings_subtab_addheading(t, "<i> Server settings</i>\n");
	constructsettings_subtab_addsetting(t,"name","Server's name",VARTYPE_ENTRY);
	constructsettings_subtab_addsetting(t,"description","Server description",VARTYPE_ENTRY);
	constructsettings_subtab_addsetting(t,"network","Network name",VARTYPE_ENTRY);
	constructsettings_subtab_addsetting(t,"password","Server password",VARTYPE_ENTRY);
	constructsettings_subtab_addsetting(t,"maxchansperuser","Allowed channels per user",VARTYPE_INTCOUNT);
	
	constructsettings_subtab_addheading(t, "\n<i> File names &amp; Places</i> (Advanced)\n");
	constructsettings_subtab_addsetting(t,"helpchan","Help channel",VARTYPE_ENTRY);
	constructsettings_subtab_addsetting(t,"motdfile","MOTD file",VARTYPE_ENTRY);
	constructsettings_subtab_addsetting(t,"glinefile","G-Line file",VARTYPE_ENTRY);
	constructsettings_subtab_addsetting(t,"klinefile","K-Line file",VARTYPE_ENTRY);
	
	t = constructsettings_addsettingssubtab(s,"floodprotection");
	
	constructsettings_subtab_addheading(t, "<i> General Flood Protection</i>\n");
	char *floodlevelvalues[4] = {"strict (recommended)", "medium", "soft", 0};
	constructsettings_subtab_addsetting_combo(t,"level","Level of flood protection",floodlevelvalues);
	char *throttlingenableddisabled[3] = {"true", "false", 0};
	constructsettings_subtab_addsetting_combo(t,"connectthrottling","Connection throttling",throttlingenableddisabled);
	constructsettings_subtab_addsetting_combo(t,"resolvedhosts","Resolve IPs to hosts",throttlingenableddisabled);
	constructsettings_subtab_addsetting(t,"MaxConnsPerIp","Connections allowed per IP",VARTYPE_INTCOUNT);

	constructsettings_subtab_addheading(t, "\n<i> Host formatting</i> (Advanced)\n");
	
	constructsettings_subtab_addheading(t, "\n<i> Reserved nicknames</i> (Advanced)\n");
	
	
	t = constructsettings_addsettingssubtab(s,"listen");
	
	constructsettings_subtab_addheading(t, "<i> Listen Ports</i> (Advanced)\n");
	
	t = constructsettings_addsettingssubtab(s,"adminaccounts");
	
	constructsettings_subtab_addheading(t, "<i> Admin accounts</i>\n");
	
	constructsettings_subtab_showbyname(s,"general");
	
}