//    WeIRCd administration tool
//    Copyright (C) 2009-2010 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "admintool.h"

GtkWidget* splashwin;

gboolean hidesplashwin(gpointer data){
	gdk_threads_enter();
	gtk_widget_hide(splashwin);
	gtk_widget_destroy(splashwin);
	gdk_threads_leave();
	return (FALSE);
}
void gui_splash_createpicdir() {
#ifdef WIN
	snprintf(picdir,149,"%sADMIN\\",localinstall_GetDataDir());
	picdir[149] = 0;
#endif
#ifndef WIN
	snprintf(picdir,149,"./");
	picdir[149] = 0;
#endif
}
char toprightlogobuf[200];
const char* gui_splash_toprightlogo() {
	gui_splash_createpicdir();
	snprintf(toprightlogobuf,499,"%stoprightlogo.png",picdir);
	return toprightlogobuf;
}

int gui_splash_show() {
	gdk_threads_enter();
	
	
	//GtkWidget* i = gtk_image_new_from_file("splash.png");gtk_widget_show(i);
	
	GdkPixmap *background;
	GdkPixbuf *pixbuf;
	GtkStyle *style; 
	 
	GError *error = NULL;
	gui_splash_createpicdir();
	char picpath[500];
	snprintf(picpath,499,"%ssplash.png",picdir);picpath[499] = 0;
	pixbuf = gdk_pixbuf_new_from_file(picpath,&error); 
	int displayerror = 0;
	if (error != NULL) {
		displayerror = 1;
		if (strlen(picdir) <= 0) {
			if (localinstall_Find() == 0) {
				gui_splash_createpicdir();
				snprintf(picpath,499,"%ssplash.png",picdir);picpath[499] = 0;
				error = NULL;
				pixbuf = gdk_pixbuf_new_from_file(picpath,&error); 
				if (error == NULL) {
					displayerror = 0;
				}
			}
		}
		if (displayerror == 1) {
			printf("Pixmap loading error (splash.png): %s\n", error->message);
			gdk_threads_leave();
			return -1;
		}else{
			printf("Pixmap loaded.\n");
		}
	}
	gdk_pixbuf_render_pixmap_and_mask(pixbuf, &background, NULL, 0);
	style = gtk_style_new ();
	style->bg_pixmap[0] = background;
	
	splashwin = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	
	gtk_window_set_position(GTK_WINDOW(splashwin), GTK_WIN_POS_CENTER);
	gtk_window_set_default_size (GTK_WINDOW(splashwin), 800, 500);
	gtk_window_set_title(GTK_WINDOW(splashwin), "WeIRCd Splash");
	gtk_window_set_decorated(GTK_WINDOW(splashwin),FALSE);
	//gtk_window_set_keep_above(GTK_WINDOW(splashwin),TRUE);
	gtk_window_set_type_hint(GTK_WINDOW(splashwin),GDK_WINDOW_TYPE_HINT_SPLASHSCREEN);
	
	gtk_widget_set_style(GTK_WIDGET(splashwin), GTK_STYLE(style));
	
	GtkWidget* vb = gtk_vbox_new(TRUE,TRUE);
	GtkWidget* l = gtk_label_new("");
	gtk_label_set_markup(GTK_LABEL(l),"<span font=\"Sans 14\" color=\"white\">\n\n<b>WeIRCd 0.8</b>.1 “Hidden Forest”</span>\n"
	"<span font=\"Sans 8\" color=\"white\">IRC chat daemon &#169; by Eloxoph, Jonas Thiem</span>\n"
	"<span font=\"Sans 8\" color=\"#ffdddd\">\n\nImage source: http://www.movingtofreedom.org/2008/09/27/crossing-afton-state-park-mn/ (creative commons attribution-share alike)</span><span font=\"Sans 12\">\n\n </span>");gtk_widget_show(l);
	gtk_label_set_justify(GTK_LABEL(l),GTK_JUSTIFY_CENTER);
	gtk_box_pack_start(GTK_BOX(vb),l,TRUE,TRUE,0);gtk_widget_show(vb);
	
	gtk_container_add(GTK_CONTAINER(splashwin), vb);
		
	gtk_widget_show(splashwin);
	g_timeout_add (3000, hidesplashwin, splashwin); 
	gdk_threads_leave();
	return 0;
}