//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

char hostbuffer[COMPILEOPTION_MAXHOSTLEN+1];
const char* generate_vhost(const char* source, const char* nick, const char* account, const char* ip, const char* host) {
	char vhosts[COMPILEOPTION_MAXHOSTLEN+1];
	strncpy(vhosts, source,COMPILEOPTION_MAXHOSTLEN);vhosts[COMPILEOPTION_MAXHOSTLEN] = 0;
	int k = 0;
	strcpy(hostbuffer,"");
	while (strlen(vhosts) > 0 && strlen(hostbuffer) <= COMPILEOPTION_MAXHOSTLEN-1) {
		if (vhosts[0] != '%') {
			hostbuffer[k] = vhosts[0];
			hostbuffer[k+1] = 0;
			k++;
			cut(vhosts,1);continue;
		}else{
			if (strstw(vhosts,"%ip") == 0) {
				cut(vhosts,strlen("%ip"));
				hostbuffer[k] = 0;
				stradd(hostbuffer,ip,COMPILEOPTION_MAXHOSTLEN);
				hostbuffer[COMPILEOPTION_MAXHOSTLEN] = 0;
				k = strlen(hostbuffer);
				continue;
			}
			if (strstw(vhosts,"%host") == 0) {
				cut(vhosts,strlen("%host"));
				hostbuffer[k] = 0;
				if (host) {
					stradd(hostbuffer,host,COMPILEOPTION_MAXHOSTLEN);
					hostbuffer[COMPILEOPTION_MAXHOSTLEN] = 0;
				}else{
					stradd(hostbuffer,ip,COMPILEOPTION_MAXHOSTLEN);
					hostbuffer[COMPILEOPTION_MAXHOSTLEN] = 0;
				}
				k = strlen(hostbuffer);
				continue;
			}
			if (nick != NULL) {
				if (strstw(vhosts,"%nick") == 0) {
					cut(vhosts,strlen("%nick"));
					hostbuffer[k] = 0;
					stradd(hostbuffer,nick,COMPILEOPTION_MAXHOSTLEN);
					hostbuffer[COMPILEOPTION_MAXHOSTLEN] = 0;
					k = strlen(hostbuffer);
					continue;
				}
			}
			if (account != NULL) {
				if (strstw(vhosts,"%account") == 0) {
					cut(vhosts,strlen("%account"));
					hostbuffer[k] = 0;
					stradd(hostbuffer,account,COMPILEOPTION_MAXHOSTLEN);
					hostbuffer[COMPILEOPTION_MAXHOSTLEN] = 0;
					k = strlen(hostbuffer);
					continue;
				}
			}
			hostbuffer[k] = vhosts[0];
			hostbuffer[k+1] = 0;
			k++;
			cut(vhosts,1);
		}

	}
	return hostbuffer;
}
const char* host_GetDefault(USER userid) {
	return generate_vhost(config_StrVal("vhost_guest"), udat(userid)->nickname, NULL, udat(userid)->ip, udat(userid)->resolvedhost);
}
const char* host_GetRegistered(USER userid, const char* account) {
	return generate_vhost(config_StrVal("vhost_user"), udat(userid)->nickname, account, udat(userid)->ip, udat(userid)->resolvedhost);
}
void host_ParseAndApply(USER userid, const char* host) {
	irc_ChangeUserHost(userid, generate_vhost(host, udat(userid)->nickname, udat(userid)->accountname, udat(userid)->ip, udat(userid)->resolvedhost));
}
void host_Apply(USER userid, const char* host) {
	irc_ChangeUserHost(userid, host);
}