//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

typedef void *SERVER;
#define NOSERVER NULL

SERVER server_Add(const char* name, const char* sid, const char* description, SERVER parent); //add a new server by name. define parent if hopcount > 1
SERVER server_GetByName(const char* name); //obtain a server handle by name
void server_SetDataPtr(SERVER serv, void* data); //set the data pointer for that server. used by the linking module to store relevant data to that server
void* server_GetDataPtr(SERVER serv); //get the set data pointer for that server. used by the linking module to store relevant data to that server
USER server_AddUser(SERVER serv, const char* nick, const char* userid, const char* modes); //add a new remote user
void server_RemoveUser(SERVER serv, const char* nick, const char* reason); //remove a specific user due to a remotely received quit reason
void server_Remove(SERVER serv); //use this on net split with that server. will also remove all sub servers and users affected
const char* server_GetName(SERVER s); //return the name of that server (returns SID if it has been set on creation)